<?php
namespace Teknisa\PAR\Controller;

use Teknisa\PAR\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Remote\FileUploader\Server;
use Teknisa\PAR\Service\ParceiroNegocioService;

class ParceiroNegocioLogotipoController extends TeknisaCrud {
    
    protected $dataSourceName = "parcnegocio_logotipo";
    protected $zhFileUploader;
    protected $parceiroService;
    
    public function __construct($crudService, $parameterBag, Server $zhFileUploader, ParceiroNegocioService $parceiroService) {
        parent::__construct($crudService, $parameterBag);
        $this->zhFileUploader  = $zhFileUploader;
        $this->parceiroService = $parceiroService;
    }
    
    public function save(Request $request, Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            
            if (is_array($row["DSDIRLOGOMARCA"])) {
                $row["DSDIRLOGOMARCA"] = $row["DSDIRLOGOMARCA"][0]["path"];
                
                if (isset($row["DSDIRLOGOMARCA_OLD"]) && !empty($row["DSDIRLOGOMARCA_OLD"])) {
                    $this->zhFileUploader->deleteFile($row["DSDIRLOGOMARCA_OLD"]);
                }
            }
            parent::save($request, $response);
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function excluirLogo(Request\Row $request, Response $response) {
        try {
            $row = $request->getRow();
            $nrparcnegocio  = $row["NRPARCNEGOCIO"];
            $nrorg          = $row["NRORG"];
            $dsdirlogomarca = $row["DSDIRLOGOMARCA"];
            
            $this->zhFileUploader->deleteFile($dsdirlogomarca);
            $this->parceiroService->atualizarCaminhoLogo($nrparcnegocio, $nrorg);
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}

?>